import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { IDataSourceDataProvider } from "./IDataSourceDataProvider";
import { IDataSourceVirtualDataProvider } from "./IDataSourceVirtualDataProvider";
import { IExternalVirtualDataSource } from "./IExternalVirtualDataSource";
import { Type } from "./type";
import { ISummaryResult } from "./ISummaryResult";
import { DataSourceRowType } from "./DataSourceRowType";
import { DataSourcePageRequestPriority } from "./DataSourcePageRequestPriority";
import { IDataSource } from "./IDataSource";
/**
 * @hidden
 */
export declare class VirtualDataSource extends BaseDataSource implements IPageCandidatesSink {
    static $t: Type;
    constructor();
    private cg;
    private cx;
    private dj;
    protected get_isSectionCollapsable(): boolean;
    protected set_isSectionCollapsable(a: boolean): void;
    protected get_isSectionExpandedDefault(): boolean;
    protected set_isSectionExpandedDefault(a: boolean): void;
    protected cr: PagePredictionEngine;
    protected get_actualBaseDataProvider(): IDataSourceDataProvider;
    protected readonly actualBaseDataProvider: IDataSourceDataProvider;
    private ck;
    dataProvider: IDataSourceVirtualDataProvider;
    private cj;
    actualDataProvider: IDataSourceVirtualDataProvider;
    private di;
    pageSizeRequested: number;
    protected resetCache(): void;
    protected resetCacheOverride(): void;
    private dh;
    maxCachedPages: number;
    protected actualPageSizePopulated: boolean;
    private c3;
    actualPageSize: number;
    private cv;
    protected get_isSortingSupported(): boolean;
    protected get_isFilteringSupported(): boolean;
    protected get_isGroupingSupported(): boolean;
    private co;
    cp: IExternalVirtualDataSource;
    protected resolveDataProvider(): IDataSourceVirtualDataProvider;
    protected propertyUpdatedOverride(a: string, b: any, c: any): void;
    private dm;
    private d0;
    private d6;
    protected resolveFullCount(a: number): number;
    private d5;
    private d4;
    private dl;
    private d2;
    protected get_isVirtual(): boolean;
    private cu;
    private c1;
    private c2;
    private cw;
    private ce;
    private ch;
    isPlaceholderItem(a: number): boolean;
    getItemAtIndex(a: number): any;
    private dr;
    private ci;
    private ct;
    private cs;
    getItemPropertyAtIndex(a: number, b: string): any;
    private ds;
    private d3;
    private d1;
    addCandidate(a: number, b: DataSourcePageRequestPriority): boolean;
    removeCandidate(a: number): void;
    transformPage(a: number): number[];
    getUnrealizedCount(): number;
    onSetItemOverride(a: number, b: any, c: any): void;
    protected refreshInternalOverride(): void;
    private d7;
    onClearItemsOverride(): void;
    onInsertItemOverride(a: number, b: any): void;
    onRemoveItemOverride(a: number, b: any): void;
    protected get_isItemIndexLookupSupported(): boolean;
    protected get_isKeyIndexLookupSupported(): boolean;
    indexOfItem(a: any): number;
    private cz;
    indexOfKey(a: any[]): number;
    private cq;
    getStickyRowPriority(a: number): number;
    unpinRow(a: any[]): void;
    pinRow(a: any[]): void;
    isRowPinned(a: number): boolean;
    private cf;
    private db;
    private c4;
    private dd;
    private c6;
    private de;
    private c7;
    private dc;
    private c5;
    private dg;
    private df;
    private c9;
    private c8;
    private da;
    getStickyRowsInRange(a: number, b: number): number[];
    isExclusivelySticky(a: number): boolean;
    getRowType(a: number): DataSourceRowType;
    private c0;
    getIsRowExpandedAtIndex(a: number): boolean;
    setIsRowExpandedAtIndex(a: number, b: boolean): void;
    getRowLevel(a: number): number;
    getRootSummaryRowCount(): number;
    private dv;
    private dw;
    getRootSummaryResults(): ISummaryResult[];
    getSectionSummaryResults(a: number): ISummaryResult[][];
    clone(): IDataSource;
    cloneProperties(a: IDataSource): void;
}
